
#include "stdio.h"
#include "evmomapl137.h"

/*PSC Module Related Registers*/              
#define PSC0_BASE  	    0x01C10000
#define PSC1_BASE  	    0x01E27000

#define PSC0_MDCTL 		(PSC0_BASE+0xA00)
#define PSC0_MDSTAT 	(PSC0_BASE+0x800)
#define PSC0_PTCMD  	*(unsigned int*) (PSC0_BASE + 0x120)
#define PSC0_PTSTAT 	*(unsigned int*) (PSC0_BASE + 0x128)

#define PSC1_MDCTL 		(PSC1_BASE+0xA00)
#define PSC1_MDSTAT 	(PSC1_BASE+0x800)
#define PSC1_PTCMD  	*(unsigned int*) (PSC1_BASE + 0x120)
#define PSC1_PTSTAT 	*(unsigned int*) (PSC1_BASE + 0x128)

/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  main( )                                                                 *
 *                                                                          *
 * ------------------------------------------------------------------------ */
void main( void )
{
    Uint32* gpio_dir = ( Uint32* )( GPIO_BASE + GPIO_DIR_BASE );
	Uint32* gpio_out = ( Uint32* )( GPIO_BASE + GPIO_OUT_DATA_BASE );
	Uint32 i;

 	/* Setup Pinmux Registers */
	PINMUX15 = 0x00888800; 

	/* Enable PSC for GPIO module */
    *(unsigned int*) (PSC1_MDCTL+4*3) = (*(unsigned int*) (PSC1_MDCTL+4*3) & 0xFFFFFFE0) | 0x0003;
    PSC1_PTCMD = 0x1;
    while( (PSC1_PTSTAT & (0x1) ) !=0) ; /*Wait for power state transition to finish*/
    while( (*(unsigned int*)(PSC1_MDSTAT+4 * 3) & 0x1F) !=0x3);

	/* Set GPIOs as output */
	*gpio_dir = 0x0;

	/* Toggle GPIOs */
    *gpio_out = 0x55555555;
	do{
  	  for(i=0; i<100000; i++) {}
	  *gpio_out = ~(*gpio_out);
	} while(1);
}
